本文主要是介绍Leetcode 第三周周赛总结(第 237 场周赛),希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!
文章目录
- 排名及做题情况
- 第一题 5734. 判断句子是否为全字母句 Easy
- 原题题目
- 第一题 比赛AC代码
- 第二题 5735. 雪糕的最大数量 Med
- 原题题目
- 第二题 比赛AC代码
- 第三题 5736. 单线程 CPU Med
- 原题题目
- 比赛时的思考
- 第三题 赛后更正代码 自解 c++是我大爹
- 第三题 赛后更正总结
- 第四题 5737. 所有数对按位与结果的异或和 Hard
- 确实想不到 cv官方代码
排名及做题情况
第一题 5734. 判断句子是否为全字母句 Easy
原题题目
第一题 比赛AC代码
class Solution {
public:bool checkIfPangram(string sentence) {vector<bool> dp(26,false);for(const auto& chr:sentence){if(!isalpha(chr) || !islower(chr)) return false;dp[chr-'a'] = true;}for(const auto& temp:dp)if(!temp) return false;return true;}
};
第二题 5735. 雪糕的最大数量 Med
原题题目
第二题 比赛AC代码
class Solution {
public:int maxIceCream(vector<int>& costs, int coins) {int ret = 0;sort(costs.begin(),costs.end());for(const auto& temp:costs){if(temp > coins) break;else{++ret;coins-=temp;}}return ret;}
};
第三题 5736. 单线程 CPU Med
原题题目
比赛时的思考
我刚刚看了看评论 是说用优先队列+排序
这些我在比赛的时候 因为之前我没怎么用过优先队列 我还比赛时去网上查 而且这些我也都想过 一个大概的思路都已经出来了 但是还是到最后感觉想法太多太乱了 没有下得去手 就没有做出来
刚刚略看了下题解 给我气的 其实我思路真的是对的 前面的基本操作我都全部写出来了 但是可能是因为经验太少了 哎 我后面再做做
第三题 赛后更正代码 自解 c++是我大爹
C++真的是我爹 我现在真觉得c++很多特性也太好用了 确实这道题整道题做完让我受益匪浅
class Solution {
public:using PII = pair<int,int>;vector<int> getOrder(vector<vector<int>>& tasks) {int size = tasks.size(),time = 0,pos = 0;vector<int> ret;vector<int> v(size,0);iota(v.begin(),v.end(),0);sort(v.begin(),v.end(),[&](int a,int b){return tasks[a][0] < tasks[b][0];});priority_queue<PII,vector<PII>,greater<PII>> q;while(true){if(q.empty())time = max(tasks[v[pos]][0],time);while(pos<=size-1 && time >= tasks[v[pos]][0])q.emplace(tasks[v[pos]][1],v[pos++]);if(pos<=size-1) time += q.top().first;ret.emplace_back(q.top().second);q.pop();if(ret.size() == size) break;}return ret;}
};
第三题 赛后更正总结
首先是我对 优先队列的理解又上升了一点 还要对C++的功能强大感觉到了确实太牛🍺了 首先就是优先队列里面自定pair 优先队列也可以自动帮你排序就不说了 还有emplace 以后我都会尽量用 首先就是效率问题
这个是我在网上查到的 emplace在插入阶段的时候 只会调用一次构造函数 和一次析构函数 而例如vector的insert首先会插入的时候 会因为重新构造一个临时变量 然后产生一次构造函数和一次析构函数 再加上vector的插入还需要又重新复制拷贝构造一次
第四题 5737. 所有数对按位与结果的异或和 Hard
确实想不到 cv官方代码
class Solution {
public:int getXORSum(vector<int>& arr1, vector<int>& arr2) {int tot1 = accumulate(arr1.begin(), arr1.end(), 0, bit_xor<int>());int tot2 = accumulate(arr2.begin(), arr2.end(), 0, bit_xor<int>());return tot1 & tot2;}
};
这篇关于Leetcode 第三周周赛总结(第 237 场周赛)的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!